C************************************************************************
C************************************************************************
C******                                                          ********
C******                     Committee Model                      ********
C******           Combination of best several model              ********
C******                                                          ********
C******        H.Fujii    University of Cambridge   27/Apr/96     ********
C************************************************************************
C************************************************************************
C
C
C
C
C ***********************************************************************
C READ ME --- the procedure
C
C This program produces the energy of all data trained using all data,
C and test energy trained using half data, both for the committee model.
C
C (1)If the best number of models changes, change the nuber of the files
C     in ***'define the name of the _out files'****
C     (1-1) in go to ii (1,2,3,****************)
C     (2-2) the statement number before 'fl='**''
C     Do not exceed 99.
C (2) Compile and run.
C     The name of output is "com.dat" at the moment.
C
C ***********************************************************************
C
C
C imodel: the number of model used.
C irow:   the number of rows for the prediction.
C
C outfl:     the file name where _out files trained using all data
C            exsists.
C            exsists.
C
C For example, outfl='outfile/out10'
C              outtestfl='outtest/out10'
C
C outfile includes _out files trained using all data.
C
C _out is prediction, standard deviation, minmum and maximum.
C _ot  is target + _out
C
C
C
C************************************************************************



      implicit real*8(a-h,l-z), integer(i,j)
      
      double precision ave(80,2100),dev(80,2100),avesum(2100),
     &aveave(2100),varave(2100),avevar(2100),devcom(2100),varcom(2100),
     &min(2100),max(2100),varsum(2100)
      character outfl*14, fl*3  
      


C************************************************************************      
       open(unit=44,file='s/committee.dat')  
	open(unit=11,file='no_of_rows.dat')

 	read(44,*)imodel,icol
C       
C
C THIS FILE READS NO oF DATA from input file "no_of_rows"

C
	read(11,*)irow
  
C ***********************************************************************


      open(3,FILE='com.dat')



C***********************************************************************
C Defining the name of _out files
C 


       do 700 ii=1,imodel

       go to (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17
     &,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36
     &,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54
     &,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,
     &74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,
     &94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,
     &111,112,113,114,115,116,117,118,119,120,121,122,123,124,125), ii
1      fl='1'
       go to 999
2      fl='2'
       go to 999
3      fl='3'
       go to 999
4      fl='4'
       go to 999
5      fl='5'
       go to 999
6      fl='6'
       go to 999
7      fl='7'
       go to 999
8      fl='8'
       go to 999
9      fl='9'
       go to 999
10     fl='10'
       go to 999
11     fl='11'
       go to 999
12     fl='12'
       go to 999
13     fl='13'
       go to 999
14     fl='14'
       go to 999
15     fl='15'
       go to 999
16     fl='16'
       go to 999
17     fl='17'
       go to 999
18     fl='18'
       go to 999
19     fl='19'
       go to 999
20     fl='20'
       go to 999
21     fl='21'
       go to 999
22     fl='22'
       go to 999
23     fl='23'
       go to 999
24     fl='24'
       go to 999
25     fl='25'
       go to 999
26      fl='26'
       go to 999
27      fl='27'
       go to 999
28      fl='28'
       go to 999
29      fl='29'
       go to 999
30      fl='30'
       go to 999
31      fl='31'
       go to 999
32      fl='32'
       go to 999
33      fl='33'
       go to 999
34      fl='34'
       go to 999
35     fl='35'
       go to 999
36     fl='36'
       go to 999
37     fl='37'
       go to 999
38     fl='38'
       go to 999
39     fl='39'
       go to 999
40     fl='40'
       go to 999
41     fl='41'
       go to 999
42     fl='42'
       go to 999
43     fl='43'
       go to 999
44     fl='44'
       go to 999
45     fl='45'
       go to 999
46     fl='46'
       go to 999
47     fl='47'
       go to 999
48     fl='48'
       go to 999
49     fl='49'
       go to 999
50     fl='50'
       go to 999
51     fl='51'
       go to 999
52     fl='52'
       go to 999
53     fl='53'
       go to 999
54     fl='54'
       go to 999
55     fl='55'
       go to 999       
56      fl='56'
       go to 999
57      fl='57'
       go to 999
58      fl='58'
       go to 999
59      fl='59'
       go to 999
60      fl='60'
       go to 999
61      fl='61'
       go to 999
62      fl='62'
       go to 999
63      fl='63'
       go to 999
64      fl='64'
       go to 999
65     fl='65'
       go to 999
66     fl='66'
       go to 999
67     fl='67'
       go to 999
68     fl='68'
       go to 999
69     fl='69'
       go to 999
70     fl='70'
       go to 999
71     fl='71'
       go to 999
72     fl='72'
       go to 999
73     fl='73'
       go to 999
74     fl='74'
       go to 999
75     fl='75'
       go to 999
76     fl='76'
       go to 999
77     fl='77'
       go to 999
78     fl='78'
       go to 999
79     fl='79'
       go to 999
80     fl='80'
       go to 999
81     fl='81'
       go to 999
82     fl='82'
       go to 999
83     fl='83'
       go to 999
84     fl='84'
       go to 999
85     fl='85'
       go to 999
86     fl='86'
       go to 999
87     fl='87'
       go to 999
88     fl='88'
       go to 999
89     fl='89'
       go to 999
90     fl='90'
       go to 999
91     fl='91'
       go to 999
92     fl='892'
       go to 999
93     fl='93'
       go to 999
94     fl='94'
       go to 999
95     fl='95'
       go to 999
96     fl='96'
       go to 999
97     fl='97'
       go to 999
98     fl='98'
       go to 999
99     fl='99'
       go to 999
100     fl='100'
       go to 999
101     fl='101'
       go to 999
102     fl='102'
       go to 999
103     fl='103'
       go to 999
104     fl='104'
       go to 999
105     fl='105'
       go to 999
106     fl='106'
       go to 999
107     fl='107'
       go to 999
108     fl='108'
       go to 999
109     fl='109'
       go to 999
110     fl='110'
       go to 999
111     fl='111'
       go to 999
112     fl='112'
       go to 999
113     fl='113'
       go to 999
114     fl='114'
       go to 999
115     fl='115'
       go to 999
116     fl='116'
       go to 999
117     fl='117'
       go to 999
118     fl='118'
       go to 999
119     fl='119'
       go to 999
120     fl='120'
       go to 999
121     fl='121'
       go to 999
122     fl='122'
       go to 999
123     fl='123'
       go to 999
124     fl='124'
       go to 999
125     fl='125'
       go to 999
      
C************************************************************************       

   
999   outfl='outprdt/out'//fl

       
      j=ii+1000

      open(j,file=outfl)


C *********************************************************************** 
C     
      imodeln=ii      
      do 300 irown=1,irow 
       read(j,*) ave(imodeln,irown), dev(imodeln,irown)

300    continue

      close(j)
      
700    continue

C ***********************************************************************
C Getting Average values of _out


         
C       write(3,110)
C       write(*,110)   

C110    format('Num of model ','All_en ','   T_en')
C110    format('Num of model ','   T_en')
           
      do 500 irown=1,irow
      
      avesum(irown)=0.0
      varsum(irown)=0.0
      aveave(irown)=0.0
      varave(irown)=0.0
      
      
        do 400 imodeln=1, imodel

            avesum(irown)=avesum(irown)+ave(imodeln,irown)
            varsum(irown)=varsum(irown)+dev(imodeln,irown)**2

400      continue

            aveave(irown)=avesum(irown)/dble(imodel)
            varave(irown)=varsum(irown)/dble(imodel)
           
500    continue

C*********************************************************************


      do 200 irown=1,irow

        avevar(irown)=0.0
        varcom(irown)=0.0
        devcom(irown)=0.0      

        do 210 imodeln=1, imodel

          avevar(irown)=avevar(irown)
     &    +(aveave(irown)-ave(imodeln,irown))**2  
            
210      continue

       varcom(irown)=varave(irown)+avevar(irown)/dble(imodel)
       devcom(irown)=sqrt(varcom(irown))
           
200    continue


C*******************************************************************


       do 301 irown=1, irow
       
       min(irown)=aveave(irown)-devcom(irown)
       max(irown)=aveave(irown)+devcom(irown)
       write(*,998) aveave(irown),devcom(irown),min(irown),max(irown)
       write(3,998) aveave(irown),devcom(irown),min(irown),max(irown)
     
301     continue


998    format(' ',F15.7,' ',F15.7,' ',F15.7,' ',F15.7)
      stop
      end
      
	
